//@author: idwyr
//@help: creating pixel outline
//@tags: texture
//@credits: 

float2 R: TARGETSIZE;
float2 scale  ;
float px=1;
struct vsInput
{
    float4 posObject : POSITION;
};

struct psInput
{
    float4 posScreen : SV_Position;
};

struct vsInputTextured
{
    float4 posObject : POSITION;
	float4 uv: TEXCOORD0;
};

struct psInputTextured
{
    float4 posScreen : SV_Position;
    float4 uv: TEXCOORD0;
};

Texture2D inputTexture <string uiname="Texture";>;

SamplerState linearSampler <string uiname="Sampler State";>
{
    Filter = MIN_MAG_MIP_LINEAR;
    AddressU = Clamp;
    AddressV = Clamp;
};

cbuffer cbPerDraw : register(b0)
{
	float4x4 tVP : VIEWPROJECTION;
};

cbuffer cbPerObj : register( b1 )
{
	float4x4 tW : WORLD;
 
	float4 stroke <bool color=true;String uiname="Stroke";> = { 1.0f,1.0f,1.0f,1.0f };
	
	float4 fill <bool color=true;String uiname="Fill";> = { 0.0f,0.0f,0.0f,1.0f };
	
	float4x4 tColor <string uiname="Color Transform";>;
};



psInputTextured VS_Textured(vsInputTextured input)
{
	psInputTextured output;
	output.posScreen = mul(input.posObject,mul(tW,tVP));
	output.uv =  input.uv ;
	return output;
}

 


float4 PS_Textured(psInputTextured input): SV_Target
{
    float4 col =  fill;
 	float2 dim = float2( R.x *scale.x, R.y*scale.y);
	
	 if ( (dim.x* input.uv.x <= px) || (dim.y*input.uv.y <= px)||
	(dim.x - dim.x* input.uv.x <= px) ||(dim.y - dim.y* input.uv.y <= px)
	) {
		col=stroke;
	   }
    return col;
}

technique11 Constant <string noTexCdFallback="ConstantNoTexture"; >
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS_Textured() ) );
		SetPixelShader( CompileShader( ps_4_0, PS_Textured() ) );
	}
}

 





